if(!dojo._hasResource["com.ibm.mm.builder.utils.pageUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.pageUtil"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.pageUtil");

dojo.require("com.ibm.mm.builder.utils.spaceUtil");


com.ibm.mm.builder.utils.pageUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.pageUtil");

com.ibm.mm.builder.utils.pageUtil.getPageIdFromSpace = function(spaceId){
	return this.getPageAccessor(spaceId).getPageID();
};

com.ibm.mm.builder.utils.pageUtil.getFirstPageInSpace = function(spaceId){
	return this.getFirstChildPageId(com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNodeId(spaceId));
};

com.ibm.mm.builder.utils.pageUtil.getFirstPageInHomeSpace = function(){
	var spaceId = com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId();
	return this.getFirstChildPageId(com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNodeId(spaceId));
};

com.ibm.mm.builder.utils.pageUtil.setPageId = function(pid, spaceId){
	this.getPageAccessor(spaceId||com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()).setPageID(pid);
	//change to view mode because enabler needs that.
	this.changePageMode("view");
};

com.ibm.mm.builder.utils.pageUtil.getPageAccessor = function(spaceId){
	return com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel(), spaceId);
};

com.ibm.mm.builder.utils.pageUtil.getPageModeAccessor = function(spaceId){
	return com.ibm.mashups.enabler.model.state.AccessorFactory.getPageModeAccessor(
		com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel()
	);
};

com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode = function(){
	return this.getPageModeAccessor(com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId()).getPageMode();
};
/**
 * Get current page id
 */
com.ibm.mm.builder.utils.pageUtil.getCurrentPageId = function(){
	return com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
};

com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode = function(){
	if(!this.currentPageNode || this.currentPageNode.getID() !== this.getCurrentPageId()){
		this.currentPageNode = this.getPageNode(this.getCurrentPageId());
	}
	return this.currentPageNode;
};

/**
 * Get current page id
 */
com.ibm.mm.builder.utils.pageUtil.getParentPageId = function(pageId){
    var p = this.getParentPageNode(pageId);
    return (p) ? p.getID() : null;
};

com.ibm.mm.builder.utils.pageUtil.getFirstChildPageId = function(pageId){
	var p = this.getFirstChildPage(pageId);
	return (p)? p.getID(): null;
};
/**
 * get first visible page
 * @param {String or NavigationNode} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getFirstChildPage = function(pageId){
	var page = this.getPageNode(pageId);
	if (page) {
		var _navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
		if (_navModel.hasChildren(page)) {
			var iter = _navModel.getChildren(page);
			while (iter.hasNext()) {
				var node = iter.next();
				if (this.isVisiable(node)) { return node; }
			}
		}
	}
	return null;
};

com.ibm.mm.builder.utils.pageUtil.getParentPageNode = function(pageId){	
	var parentNode = null; 

	var navUtil = com.ibm.mm.builder.utils.navigationUtil;
	var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
	var _navModel = navUtil.getNavigationModel();
	var pid = this._getPageId(pageId);
	if(pid){
		parentNode = _navModel.getParent(pid).start();
	}
	return parentNode || navUtil.getNavigationRootNode(spaceUtil.getCurrentSpaceId());
};

com.ibm.mm.builder.utils.pageUtil.getSiblingPages = function(pageId){
   	return this.getChildPages(this.getParentPageNode(pageId));
};

com.ibm.mm.builder.utils.pageUtil.getChildPages = function(page){
	if (typeof page === "string") {
		page = this.getPageNode(page);
		if (!page) { return null; }
	}
	var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	return navModel.hasChildren(page) ? navModel.getChildren(page) : null;
};
/**
 * Determine the first page to render
 */
com.ibm.mm.builder.utils.pageUtil.getDefaultPage = function(pageId){
	return this.getPageNode(pageId) || this.getFirstRootPageId();
};

com.ibm.mm.builder.utils.pageUtil.getDefaultPageId = function(pageId) {
	var p = this.getDefaultPage(pageId);
	if (!p.getID) { return p; } //added this line
	return (p) ? p.getID() : null;
};

/**
 * Determine the first page to render
 */
com.ibm.mm.builder.utils.pageUtil.getFirstRootPageId = function(){
	var utils = com.ibm.mm.builder.utils;
	var rootId = utils.navigationUtil.getNavigationRootNodeId(utils.spaceUtil.getCurrentSpaceId());
	return this.getFirstChildPageId(rootId);
};

/**
 * Determine the page id of the page in the current space whose page title matches title using locale.
 * Used by links on Welcome page of Welcome Space to switch to other pages in the Welcome Space. 
 */
com.ibm.mm.builder.utils.pageUtil.getCurrentSpacePageIdByPageTitle = function(title, locale) {
	var iter = this.getSiblingPages(this.getFirstRootPageId());
	while (iter.hasNext()) {
		var page = iter.next();
		if (this.getPageTitle(page.getID(), locale) == title) { return page.getID(); }
	}
	return null;
};

/**
 * Get page content by page id
 * If pageId is null, current page content is returned.
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getPageContent = function(pageId){

    var layoutModel = this.getPageLayoutModel(pageId);
    if (!layoutModel) { return null; }
    
    var lmRoot = layoutModel.getRoot().start();
    if (lmRoot) { return lmRoot.getFragment(); }
    
    alert(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_NO_PAGE_OR_NET_DISCONNECT_0);
    return null;
};

com.ibm.mm.builder.utils.pageUtil.getPageTitle = function(page, locale) {
	if (!page) { return null; }
	
	if (dojo.isString(page)) {
		page = this.getPageNode(page);
	}
	
	return com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(page, locale);
};

com.ibm.mm.builder.utils.pageUtil.getUnescapedPageTitle = function(page, locale){
    if (!page) { return null; }
	
	if (dojo.isString(page)) {
		page = this.getPageNode(page);
	}
	
	return com.ibm.mm.builder.utils.enablerUtil.getUnescapedNodeTitle(page, locale);
};

com.ibm.mm.builder.utils.pageUtil.getCurrentPageTitle = function(locale){
	return this.getPageTitle(this.getDefaultPageId(), locale);
};

/** 
 * @param {Object} pageId
 * @param {Object} locale
 */
com.ibm.mm.builder.utils.pageUtil.getPageDescription = function(pageId, locale){
    var node = this.getPageNode(pageId);
	return com.ibm.mm.builder.utils.enablerUtil.getNodeDescription(node, locale);
};

/**
 * return page layout itemset
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getPageLayoutItemSet = function(pageId){

    var layoutModel = this.getPageLayoutModel(this._getPageId(pageId));
    if (!layoutModel) { return null; }
    
    var lmRoot = layoutModel.getRoot().start();
    if (lmRoot) {
        return lmRoot.getMetaData(com.ibm.mm.builder.constant.layoutWidgetItemSet);
    }
    return null;
};

/**
 * Create page with page title
 * @param {String} title
 * @param {String} parentId, if null, the new page will created as sibling of current page.
 */
com.ibm.mm.builder.utils.pageUtil.createPage = function(title, parentId, onErrorCb){
	var utils = com.ibm.mm.builder.utils;
	var parentPage = this.getPageNode(parentId || this.getParentPageId() || 
		utils.navigationUtil.getNavigationRootNodeId(utils.spaceUtil.getCurrentSpaceId()));
	
	var _navModel = utils.navigationUtil.getNavigationModel();
	
	// create page
    var newPage = _navModel.create(null);
    newPage.setTitle(title, dojo.locale);
	newPage.setTitle(title, ibmConfig["default.locale"]);
	//we change this logic to save theme when save page instead saving theme after creating page.
    var themeId = utils.themeUtil.getThemeId(parentPage.getID());
    if (!utils.themeUtil.getThemeModel().find(themeId).start()){
        themeId = utils.themeUtil.getDefaultThemeId();
    }
    newPage.setTheme(themeId);
    
	_navModel.insert(newPage, parentPage, null);
	
	// create layout
	var layoutModel = _navModel.getLayoutModel(newPage.getID());
	if (layoutModel) {
		var lmRoot = layoutModel.create();
		layoutModel.insert(lmRoot);
		
		// set empty fragment
		lmRoot.setFragment(" ");
		
		// commit changes
		var deferred = _navModel.commit();
		var newNode = null;
		deferred.setOperationCallback(function(node, operation, status, params) {
			if(!node && status >= 400){
				com.ibm.mm.builder.utils.pageUtil.LOGGER.severe("createPage", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_PUB_API_CREATE_PAGE_1,[status]));
			}else{
				newNode = node.getID();
			}
		});
		
		deferred.setFinishedCallback(function(ret, statusCode) {
			if(!newNode || statusCode >= 400){
				if (onErrorCb) {
					onErrorCb();
				}
				com.ibm.mm.builder.utils.pageUtil.LOGGER.severe("createPage", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_PUB_API_CREATE_PAGE_1,[statusCode]));
			}else{
				dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null, {expires: -1});
				var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
				es.broadcastEvent("com.ibm.mashups.builder.pageCreated", newNode);
				es.broadcastEvent("com.ibm.mashups.builder.switchPage", newNode);
				es.broadcastEvent("com.ibm.mashups.builder.spacemanager.pageCreated", newNode);
			}
		});
		deferred.start(false);
	} else {
		this.LOGGER.trace("cannot get layoutmodel");
	}
};

/**
 * Update page's content, title and theme
 * @param {Hash} pageProps, example: {content: "test", title:"new name", theme:"columnlayout"}
 * @param {String} parentId, if null, the new page will created as sibling of current page.
 */
com.ibm.mm.builder.utils.pageUtil.updatePage = function(pageId, pageProps){
	var pageNode = pageId ? this.getPageNode(pageId) : this.getCurrentPageNode();
	if (!pageNode) { return; }
	var _navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	var need_to_commit = false;
	var target_page = null;
	if(pageProps.content){
		if (_navModel.hasLayoutModel(pageNode)) {
			
			var layoutModel = _navModel.getLayoutModel(pageNode);
			if (layoutModel) {
				var lmRoot = layoutModel.getRoot().start() || layoutModel.create();
				lmRoot.setFragment(pageProps.content);
				layoutModel.insert(lmRoot);
				need_to_commit = true;
			}
		}
	}
	
	if(pageProps.title && pageProps.title != this.getPageTitle(pageNode)){
		if(this.validatePageName(pageProps.title)){
			pageNode.setTitle(pageProps.title, dojo.locale);
			need_to_commit = true;
		}else{
			return;
		}
	}
	
	if(pageProps.description && pageProps.description != com.ibm.mm.builder.utils.enablerUtil.getNodeDescription(pageNode)){
		pageNode.setDescriptione(pageProps.description, dojo.locale);
		need_to_commit = true;
	}
	
	var themeId = com.ibm.mm.builder.utils.themeUtil.getThemeId(pageNode);
	if (pageProps.theme && pageProps.theme != themeId) {
		pageNode.setTheme(pageProps.theme);
		need_to_commit = true;
	}
	//if theme is null, save default theme as well.
	if (themeId === "null") {
		pageNode.setTheme(com.ibm.mm.builder.utils.themeUtil.getDefaultThemeId());
		need_to_commit = true;
	}
	
	if (need_to_commit){
		_navModel.commit().start();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
	}
};

com.ibm.mm.builder.utils.pageUtil.saveCurrentPage = function(content){
	var pageProps = {};
	pageProps.content = content || this.getPageContent();
	this.updatePage(null, pageProps);
	
};

/**
 * Delete page
 * @param {String} parentId, if null, current page will be deleted
 */
com.ibm.mm.builder.utils.pageUtil.deletePage = function(pageId){
	//set page to false to disable the page save checker.
	com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
	var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
	navModel.remove(this._getPageId(pageId));
	navModel.commit().start();
	//reset current page after delete page
	com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setID(null);
};

com.ibm.mm.builder.utils.pageUtil.isRoot = function(pageId){
	var node = this.getPageNode(pageId);
	var currentSpaceId = com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId();
	return !node || node.getID() == com.ibm.mm.builder.utils.navigationUtil.getNavigationRootNodeId(currentSpaceId);

};
/**
 * Get page layout model
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getPageLayoutModel = function(pageId){
    var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
    return navModel.getLayoutModel(this._getPageId(pageId));
};

com.ibm.mm.builder.utils.pageUtil.getPageLayoutNode = function(pageId){
   var layoutModel = this.getPageLayoutModel(pageId);
   if (layoutModel) { return layoutModel.getRoot().start(); }
};

/**
 * Get the page node, return current page node if pageId is null
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil.getPageNode = function(pageId){
	var pid = this._getPageId(pageId);
	if (pid) {
		var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel(true);
		try {
			return navModel.find(pid).start();
		} catch (e) {
			return null;
		}
	}
};

/**
 * Get the page id, return current page id if pageId is null
 * @param {String} pageId
 */
com.ibm.mm.builder.utils.pageUtil._getPageId = function(pageId){
    return pageId || this.getCurrentPageId();
};

/**
 * Check page name , if name is valid , return true , or , return false
 * //todo change to one ui for error message display instead of alert
 */
com.ibm.mm.builder.utils.pageUtil.validatePageName = function(title){
   var cwm = com.ibm.mm.builder.coreWidgetsMessages;
    if (!title) {
        return false;
    }
    if (title.length === 0) {
        alert(cwm.E_PAGE_UTIL_INVALID_NAME_EMPTY_0);
        return false;
    }
    title = dojo.trim(title);
    if (title.length === 0) {
        alert(cwm.E_PAGE_UTIL_INVALID_NAME_BLANK_0);
        return false;
    }
    
    if (title.length >= 256) {
        alert(cwm.E_PAGE_UTIL_INVALID_NAME_LENGTH_0);
        return false;
    }
    
    var match = ibmConfig[com.ibm.mashups.enabler.services.ConfigConstants.BUILDER_TITLE_FILTER_REGEXP];
    if (match) {
        if (title.match(match)) {
            alert(cwm.E_PAGE_UTIL_INVALID_NAME_CHAR_0);
            return false;
        }
    }
    return true;
};

com.ibm.mm.builder.utils.pageUtil.getEmptyPageMessage = function(msg){
	var empty_content = 
		"<div class='empty_div'>"+
			"<div class='empty_outer_div'>" +
				"<div class='empty_inner_div'>" +
				com.ibm.mm.builder.utils.htmlUtil.formatMessage(msg) +
				"</div>" +
			"</div>"+
		"</div>";
    return empty_content;
};

com.ibm.mm.builder.utils.pageUtil.encodeBase64 = function(str){
    function unicode2utf8(str){
        var result = [];
        for (var i = 0, len = str.length; i < len; i++) {
            var ch = str.charCodeAt(i);
            if ((ch >= 0x0001) && (ch <= 0x007F)) {
                result.push(str.charAt(i));
            }
            else 
                if (ch > 0x07FF) {
                    result.push(String.fromCharCode(0xE0 | ((ch >> 12) & 0x0F)));
                    result.push(String.fromCharCode(0x80 | ((ch >> 6) & 0x3F)));
                    result.push(String.fromCharCode(0x80 | ((ch >> 0) & 0x3F)));
                }
                else {
                    result.push(String.fromCharCode(0xC0 | ((ch >> 6) & 0x1F)));
                    result.push(String.fromCharCode(0x80 | ((ch >> 0) & 0x3F)));
                }
        }
        return result.join("");
    }
    str = unicode2utf8(str);
    
    var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var out, i, len;
    var c1, c2, c3;
    
    len = str.length;
    var i = 0;
    out = [];
    while (i < len) {
        c1 = str.charCodeAt(i++) & 0xff;
        if (i === len) {
            out.push(base64EncodeChars.charAt(c1 >> 2));
            out.push(base64EncodeChars.charAt((c1 & 0x3) << 4));
            out.push("==");
            break;
        }
        c2 = str.charCodeAt(i++);
        if (i === len) {
            out.push(base64EncodeChars.charAt(c1 >> 2));
            out.push(base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4)));
            out.push(base64EncodeChars.charAt((c2 & 0xF) << 2));
            out.push("=");
            break;
        }
        c3 = str.charCodeAt(i++);
        out.push(base64EncodeChars.charAt(c1 >> 2));
        out.push(base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4)));
        out.push(base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6)));
        out.push(base64EncodeChars.charAt(c3 & 0x3F));
    }
    return out.join("");
};

com.ibm.mm.builder.utils.pageUtil.isEmptyPage = function(pageNode){
	if (!pageNode) { return true; }
	return !com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().hasLayoutModel(pageNode);
};

com.ibm.mm.builder.utils.pageUtil.isVisiable = function(node){
	if (!node) { return false; }
	if (dojo.isString(node)) {
		node = this.getPageNode(node);
	}
	if (!node.isHidden()) { return true; }
	return com.ibm.mm.builder.utils.spaceUtil.isBusinessSpaceServer() ? this.canEdit(node) : false;
};

com.ibm.mm.builder.utils.pageUtil.canEdit = function(node){
//	if (!node) { return false; }
//	var ac = com.ibm.mm.builder.utils.acModelUtil;
//	if (ac.isPageOwner(node.getID())) { return true; }
//	if (ac.getUserPermission(node.getID()) === ac.EDIT) { return true; }
//	return false;
	var enabler = com.ibm.mashups.enabler;
	var navModel = enabler.navigation.Factory.getNavigationModel();
	var page = navModel.find(node.getID()).start();
	var type = page.getNavigationElementType();
	if (type == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE) {
		var sc = page.getContent().start();	 
		if (page.getMetaData("com.ibm.portal.static.page.file.name.html")) {
			return sc.confirmSetStaticMarkup("");
		} else {
			if(page.hasRole(com.ibm.mashups.enabler.ac.RoleType.ADMIN) || 
				page.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR) ||
				page.hasRole("Privileged User")){
				return true;
			} else 	{ 
				return false; }
		}
	} else if (type ==  com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_LABEL) {
		return page.confirmSetHidden(true);
	} else  {
		return false;	
	} 
};

com.ibm.mm.builder.utils.pageUtil.updatePageTitle = function(){
	var pageTitle = this.getUnescapedPageTitle(this.getCurrentPageId());
	var pageContext = com.ibm.mashups.enabler.context.Factory.getPageContext();
	// use the enabler API to set the HTML page title in browser
	if (pageContext){
		if (!pageTitle || dojo.trim(pageTitle) == "") {
			//dojo.doc.title = builderConfig.productName
			pageContext.setBrowserTitle(builderConfig.productName);
		} else {
			//dojo.doc.title = builderConfig.productName + " - " + pageTitle;
			pageContext.setBrowserTitle(builderConfig.productName + " - " + pageTitle);
		}		
	}
};

com.ibm.mm.builder.utils.pageUtil.isGlobalPage = function(){
	return dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid) && dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid) !== "null";
};

com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm = function(callback, cancelcb){
	if(com.ibm.pb.contextMenu.sharedActions.widgetEditModeChecker()) {
		// skip the page dirty check and display another confirm dialog if there is unsaved widget
		return;
	}
	if (com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty()) {
		var cws = com.ibm.mm.builder.coreWidgetsStrings;
		var saveConfirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
			contentWarning: cws.I_PAGE_SAVE_WARNING,
			contentQuestion: cws.I_PAGE_SAVE_SUGGEST,
			btnSaveText: cws.I_COMMON_SAVE,
			btnNotSaveText: cws.I_PAGE_SAVE_NO_SAVE,
			btnCancelText: cws.I_PAGE_SAVE_KEEP_EDIT,
			hideNotSave: true,
			callbackSave: callback,
			callbackNotSave: callback,
			callbackCancel: cancelcb
		});
		saveConfirmDlg.show();
	}
	else {
		if (callback) {
			callback();
		}
	}
};

com.ibm.mm.builder.utils.pageUtil.changePageMode = function(mode){
	if (mode == "view" || mode == "edit") {
		com.ibm.mm.builder.utils.pageUtil.getPageModeAccessor().setPageMode(mode);
		com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel().commit().start();
	}
};

com.ibm.mm.builder.utils.pageUtil.isPageDescriptionLengthExceed=function(description){
    var descBytes = description.replace(/[^\x00-\xff]/gi, "--").length; // get the byte count of description string
    var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
    var maxLength = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.LIMIT_PAGE_DESCRIPTION);
    if (descBytes > maxLength) {
        return maxLength;
    }
    else {
        return 0;
    }
};

com.ibm.mm.builder.utils.pageUtil.getLayoutModel = function(){
	var navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
	var pageAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(navStateModel, null);
	var pageID = pageAccessor.getPageID();
	var navigationModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
	var page = navigationModel.find(pageID).start();
	var lm = navigationModel.getLayoutModel(page);
	return lm;
};

com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId = function(widgetId){
    var lm = com.ibm.mm.builder.utils.pageUtil.getLayoutModel();
    var layoutControl = lm.find(widgetId).start();
    if (!layoutControl) {
        // now we try to find it through a loop as the above assumption is actually invalid and should not have been made
        layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetIdContinue(lm.getRoot().start(), widgetId);
    }
    return layoutControl;
};
com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetIdContinue = function(node, widgetId) {
    var ret = null;
    var lm = com.ibm.mm.builder.utils.pageUtil.getLayoutModel();
    if (node.getLayoutNodeType() == com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTAINER) {
        if (lm.hasChildren(node)) {
            var childrenIter = lm.getChildren(node);
            while (childrenIter.hasNext()) {
                ret = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetIdContinue(childrenIter.next(), widgetId);
                if (ret) {
                    return ret;
                }
            }
        }
    }
    else if (node.getLayoutNodeType() == com.ibm.mashups.enabler.layout.Constants.LAYOUT_CONTROL) {
        var wm = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
        var testWidgetId = wm.getWidgetWindow(node).start().getID();
        if (testWidgetId == widgetId) {
            return node;
        }
    }
    return ret;
};

}
