if(!dojo._hasResource["com.ibm.mm.builder.utils.spaceUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.spaceUtil"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.spaceUtil");

dojo.require("com.ibm.mm.builder.utils.userUtil");
dojo.require("com.ibm.mm.builder.utils.enablerUtil");

/**
 * Return navigation model, if refresh is true, the cache will be clean and retrieve the model again.
 * @param {boolean} refresh
 * @param {string} id
 */
(function(){
var enabler = com.ibm.mashups.enabler;
var builder = com.ibm.mm.builder;
var constant = builder.constant;
var strategy = enabler.strategy;
var ef = enabler.model.Factory;
var af = enabler.model.state.AccessorFactory;
var spaceFactory = com.ibm.mashups.enabler.space.Factory;
var userUtil = builder.utils.userUtil;
var enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
var cs = com.ibm.mashups.services.ServiceManager.getService(enabler.services.ConfigService.SERVICE_NAME);
var configConstants = com.ibm.mashups.enabler.services.ConfigConstants;
var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
var cws = com.ibm.mm.builder.coreWidgetsStrings;

var spaceUtil = {
	getSpaceModel: function(refresh) {
		if (refresh || !this.spaceModel) {
			if (this.spaceModel) {
				delete this.spaceModel;
			};
			var spaceModel = spaceFactory.getSpaceModel();
			spaceModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(com.ibm.mm.builder.constant.NavigationPageSize));
			this.spaceModel = spaceModel;
		} 
		//clean cache
		this.currentSpaceNode = null;
		
		return this.spaceModel;
	},
	
	getSpaceByNavigation: function(navNode) {
		if (navNode) { return this.getSpaceModel().findSpaceByNavigation(navNode).start(); }
		return null;
	},
	
	getSpaceIdByPageId: function(pageId) {
		var s = this.getSpaceByNavigation(com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId));
		if (s) { return s.getID(); }
		return null;
	},
	
	getCurrentSpaceId: function() {
		return this.getSpaceAccessor().getSpaceID();
	},
	
	getCurrentSpaceNode: function() {
		if (!this.currentSpaceNode || this.currentSpaceNode.getID() !== this.getCurrentSpaceId()) {
			this.currentSpaceNode = this.getSpaceNode(this.getCurrentSpaceId());
		}
		return this.currentSpaceNode;
	},
	
	setSpaceId: function(sid) {
		this.getSpaceAccessor().setSpaceID(sid);
		com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().commit().start();
		if (!sid) {
			dojo.cookie("inPersonalSpace", "true");
		}
		else {
			dojo.cookie("inPersonalSpace", null);
		}
	},
	
	getSpaceAccessor: function() {
		this.spaceAccessor = this.spaceAccessor ||
		af.getSpaceAccessor(com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel());
		return this.spaceAccessor;
	},
	
	getWelcomeSpaceId: function() {
		return cs.getValue(configConstants.WELCOME_SPACE_ID);
	},
	
	getHomeSpaceId: function() {
		if (userUtil.isLookasideEnabled("com.ibm.mashups.user.DEFAULT_SPACE")) {
			try {
				this._homeSpaceId = this._homeSpaceId || userUtil.getCurrentUser().getAttribute("com.ibm.mashups.user.DEFAULT_SPACE");
				//check whether the space exists
				if (this._homeSpaceId === "null") { return null; }
				if (this._homeSpaceId === "-1") { return null; }
				return this._homeSpaceId;
			} catch (e) {
				return null;
			}
		}
		return null;
	},
	
	setHomeSpaceId: function(sid) {
		sid = sid || "-1";
		this._homeSpaceId = sid;
		var userModel = userUtil.getUserModel();
		var user = userUtil.getCurrentUser();
		if (user) {
			user.setAttribute("com.ibm.mashups.user.DEFAULT_SPACE", sid);
			userModel.commit().start();
			es.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
		}
	},
	
	isHomeSpace: function(spaceId) {
		return this.getHomeSpaceId() === spaceId;
	},
	
	isWelcomeSpace: function(spaceId){
		return this.getWelcomeSpaceId() === spaceId;
	},
	
	isPersonalSpace: function(spaceId) {
		return !this.getCurrentSpaceId();
	},
	
	getSpaceTitle: function(spaceId, locale) {
		return enablerUtil.getNodeTitle(this.getSpaceNode(spaceId), locale) || this.getPersonalSpaceTitle();
	},
	
	getPersonalSpaceTitle: function() {
		if (ibmConfig.PERSONAL_SPACE_KEY && cws[ibmConfig.PERSONAL_SPACE_KEY]) { return cws[ibmConfig.PERSONAL_SPACE_KEY]; }
		return cws.I_SPACE_PERSONAL_SPACE;
	},
	
	getSpaceIconURL: function(space) {
		var names = space.getMetaDataNames();
		for (var i = 0; i < names.length; i++) {
			// this meta is for "iconUrl"
			if (names[i] && (names[i] == "iconUrl" || names[i].search("^\{.*\}iconUrl$") !== -1)) { return space.getMetaData(names[i]); }// JSLINT-IGNORE:
		}
		return null;
	},
	
	setSpaceIconURL: function(space, iconUrl) {
		var names = space.getMetaDataNames();
		var found = false;
		for (var i = 0; i < names.length; i++) {
			// this meta is for "iconUrl"
			if (names[i] && (names[i] == "iconUrl" || names[i].search("^\{.*\}iconUrl$") !== -1)) { // JSLINT-IGNORE:
				space.setMetaData(names[i], iconUrl);
				found = true;
			}
		}
		
		if (!found) {
			space.setMetaData("{http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/extensions}iconUrl", iconUrl);
		}
		
		return;
	},
	
	getSpaceNode: function(spaceId) {
		if (spaceId === this.getCurrentSpaceId() && this.currentSpaceNode) { return this.currentSpaceNode; }
		spaceId = spaceId || this.getCurrentSpaceId();
		if (spaceId) { return this.getSpaceModel().find(spaceId).start(); }
	},
	//todo remove duplicate code to check title.
	validateSpaceName: function(title) {
		var cwm = com.ibm.mm.builder.coreWidgetsMessages;
		if (!title) { return false; }
		if (title.length === 0) {
			alert(cwm.E_SPACE_UTIL_INVALID_NAME_EMPTY_0);
			return false;
		}
		title = dojo.trim(title);
		if (title.length === 0) {
			alert(cwm.E_SPACE_UTIL_INVALID_NAME_BLANK_0);
			return false;
		}
		
		if (title.length >= 256) {
			alert(cwm.E_SPACE_UTIL_INVALID_NAME_LENGTH_0);
			return false;
		}
		
		var match = ibmConfig[configConstants.BUILDER_TITLE_FILTER_REGEXP];
		if (match) {
			if (title.match(match)) {
				alert(cwm.E_SPACE_UTIL_INVALID_NAME_CHAR_0);
				return false;
			}
		}
		return true;
	},
	
	isVisiable: function(node) {
		if (!node) { return false; }
		if (dojo.isString(node)) {
			node = this.getSpaceNode(node);
		}
		if (!node.isHidden()) { return true; }
		return this.isBusinessSpaceServer() ? this.canEdit(node) : false;
	},
	
	canEdit: function(node) {
		if (!node) { return false; }
		var ac = com.ibm.mm.builder.utils.acModelUtil;
		return ac.isSpaceOwner(node) || ac.canEditSpace(node);
	},
	
	isBusinessSpaceServer: function() {
		return cs.getValue(configConstants.SERVER_TYPE) == configConstants.SERVER_TYPE_BSPACE;
	}
};

com.ibm.mm.builder.utils.spaceUtil = spaceUtil;
})();

}
