if(!dojo._hasResource["com.ibm.mm.builder.widget.MumColorPalette"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.MumColorPalette"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.MumColorPalette");

dojo.require("dijit.ColorPalette");

dojo.declare(
	"com.ibm.mm.builder.widget.MumColorPalette",
	dijit.ColorPalette,
{
	// palette: String
	palette: "8x16",
	palette_rtl: "8x16_rtl",

	// _palettes: Map
	// 		This represents the value of the colors.
	//		The first level is a hashmap of the different arrays available
	//		The next two dimensions represent the columns and rows of colors.
	_palettes: {
		"8x16": [
			["#FFFFFF", "#DDDDDD", "#BBBBBB", "#999999", "#666666", "#444444", "#222222", "#000000"],
			["#FFEEEE", "#FFFFDD", "#FFFFEE", "#EEFFEE", "#EEFFFF", "#EEEEFF", "#FFEEFF", "#FFEEFF"],
			["#FFCCCC", "#FFFFBB", "#FFFFCC", "#CCFFCC", "#CCFFFF", "#CCCCFF", "#FFCCFF", "#FFCCFF"],
			["#FFAAAA", "#FFEE99", "#FFFFAA", "#AAFFAA", "#AAFFFF", "#AAAAFF", "#EEAAFF", "#FFAAFF"],
			["#FF8888", "#FFDD88", "#FFFF88", "#88FF88", "#88FFFF", "#8888FF", "#DD88FF", "#FF88FF"],
			["#FF6666", "#FFCC66", "#FFFF66", "#66FF66", "#66FFFF", "#6666FF", "#CC66FF", "#FF66FF"],
			["#FF4444", "#FFBB44", "#FFFF44", "#44FF44", "#44FFFF", "#4444FF", "#BB44FF", "#FF44FF"],
			["#FF2222", "#FFAA22", "#FFFF22", "#22FF22", "#22FFFF", "#2222FF", "#AA22FF", "#FF22FF"],
			["#FF0000", "#FF9900", "#FFFF00", "#00FF00", "#00FFFF", "#0000FF", "#9900FF", "#FF00FF"],
			["#DD0000", "#DD8800", "#DDDD00", "#00DD00", "#00DDDD", "#0000DD", "#8800DD", "#DD00DD"],
			["#BB0000", "#BB7700", "#BBBB00", "#00BB00", "#00BBBB", "#0000BB", "#7700BB", "#BB00BB"],
			["#990000", "#996600", "#999900", "#009900", "#009999", "#000099", "#660099", "#990099"],
			["#770000", "#774400", "#777700", "#007700", "#007777", "#000077", "#550077", "#770077"],
			["#550000", "#553300", "#555500", "#005500", "#005555", "#000055", "#440055", "#550055"],
			["#330000", "#332200", "#333300", "#003300", "#003333", "#000033", "#330033", "#330033"],
			["#110000", "#111100", "#111100", "#001100", "#001111", "#000011", "#220011", "#110011"]
		]
	},
	_firstLtrColor: "#FFFFFF",
	// _imagePaths: Map
	//		This is stores the path to the palette images
	_imagePaths: {
		"8x16": dojo.moduleUrl("com.ibm.mm.builder", "widget/templates/images/color_palette.png"),
		"8x16_rtl": dojo.moduleUrl("com.ibm.mm.builder", "widget/templates/images/color_palette_rtl.png")
	},

	// templatePath: String
	//		Path to the template of this widget.
	templateString: 
		'<div class="mumColorPalette">'+
			'<div class="dijitInline dijitColorPalette" style="position:relative">'+
				'<div class="dijitColorPaletteInner" dojoAttachPoint="divNode" waiRole="grid" tabIndex="-1">'+
					'<img class="dijitColorPaletteUnder" dojoAttachPoint="imageNode" waiRole="presentation">'+
				'</div>'+
			'</div>'+
		'</div>',
	
	// _paletteDims: Object
	//		Size of the supported palettes for alignment purposes.
	_paletteDims: {
		"8x16": {"width": "166px", "height": "326px"}
	},
	
	indicator:null,
	
	inputId:null,
	
	postCreate: function(){
		// A name has to be given to the colorMap, this needs to be unique per Palette.
		dojo.mixin(this.divNode.style, this._paletteDims[this.palette]);
		
		var choices = [];
		if (!builderConfig.isBidi) {
			this.imageNode.setAttribute("src", this._imagePaths[this.palette]);
			choices = this._palettes[this.palette];
		} else {
			this.imageNode.setAttribute("src", this._imagePaths[this.palette_rtl]);
			choices = this._palettes[this.palette][0][0] === this._firstLtrColor ? 
				dojo.map(this._palettes[this.palette], function(row){ return row.reverse(); }) : 
					this._palettes[this.palette];
		}
		
		this.domNode.style.position = "relative";
		this._cellNodes = [];	
		//this.colorNames = dojo.i18n.getLocalization("dojo", "colors", this.lang);
		var url = dojo.moduleUrl("dojo", "resources/blank.gif"),
            colorObject = new dojo.Color(),
		    coords = this._paletteCoords;
		for(var row=0; row < choices.length; row++){
			for(var col=0; col < choices[row].length; col++) {
                var imgNode = dojo.doc.createElement("img");
                imgNode.src = url;
                dojo.addClass(imgNode, "dijitPaletteImg");
                var color = choices[row][col];
                imgNode.color = color;
                
                var red = parseInt("0x" + color.substr(1, 2), 16);
                var green = parseInt("0x" + color.substr(3, 2), 16);
                var blue = parseInt("0x" + color.substr(5, 2), 16);
				imgNode.title = imgNode.alt = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_COLOR_PICKER_COLOR_TITLE, [red, green, blue]);
                var imgStyle = imgNode.style;
                imgStyle.color = imgStyle.backgroundColor = imgNode.color;
                var cellNode = dojo.doc.createElement("span");
                cellNode.appendChild(imgNode);
                dojo.forEach(["Dijitclick", "MouseEnter", "Focus", "Blur"], function(handler) {
                    this.connect(cellNode, "on" + handler.toLowerCase(), "_onCell" + handler);
                }, this);  // JSLINT-IGNORE:
                this.divNode.appendChild(cellNode);
                var cellStyle = cellNode.style;
                cellStyle.top = coords.topOffset + (row * coords.cHeight) + "px";
                cellStyle.left = coords.leftOffset + (col * coords.cWidth) + "px";
                dojo.attr(cellNode, "tabindex", "-1");
                dojo.addClass(cellNode, "dijitPaletteCell");
                dijit.setWaiRole(cellNode, "gridcell");
                cellNode.index = this._cellNodes.length;
                this._cellNodes.push(cellNode);
            }
		}
		this._xDim = choices[0].length;
		this._yDim = choices.length;
		this.connect(this.divNode, "onfocus", "_onDivNodeFocus");

		// Now set all events
		// The palette itself is navigated to with the tab key on the keyboard
		// Keyboard navigation within the Palette is with the arrow keys
		// Spacebar selects the color.
		// For the up key the index is changed by negative the x dimension.		

		var keyIncrementMap = {
			UP_ARROW: -this._xDim,
			// The down key the index is increase by the x dimension.	
			DOWN_ARROW: this._xDim,
			// Right and left move the index by 1.
			RIGHT_ARROW: 1,
			LEFT_ARROW: -1
		};
		for(var key in keyIncrementMap){
		    if (Object.prototype.hasOwnProperty.call(keyIncrementMap, key)) {
				this._connects.push(dijit.typematic.addKeyListener(this.domNode, {
					keyCode: dojo.keys[key],
					ctrlKey: false,
					altKey: false,
					shiftKey: false
				}, this, function(){
					var increment = keyIncrementMap[key];
					return function(count){
						this._navigateByKey(increment, count);
					};
				}(), this.timeoutChangeRate, this.defaultTimeout));
			}
		}
	},

	_onBlur:function(){
		dojo.style(this.domNode.parentNode, "display", "none");	
	},
	
	onChange: function(color){
		if (this.indicator) {
			dojo.style(this.indicator, "backgroundColor", color);
		}
		if (this.inputId) {
			dojo.byId(this.inputId).value = color;
		}
		this._onBlur();
		dojo.publish("ColorChanged",[this.indicator]);		
	},
	
	_focusFirst: function(){
		this._currentFocus = builderConfig.isBidi ? 7 : 0;
		var cellNode = this._cellNodes[this._currentFocus];
		window.setTimeout(function(){dijit.focus(cellNode);}, 0);
	}
	
});

}
