if(!dojo._hasResource["com.ibm.mm.builder.widget.MumResizeHandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.MumResizeHandler"] = true;
dojo.provide("com.ibm.mm.builder.widget.MumResizeHandler");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("com.ibm.mm.builder.widget.MumResizeHandler", [dijit._Widget, dijit._Templated], {
	
	templateString: 
		'<div dojoAttachEvent="onmousedown: _beginSizing" class="mumHtmlResizeHandler" style="display:none">'+
			'<img src="/mum/images/resize.png" alt="" dojoAttachPoint="resizeHandlerImage"/>'+
		'</div>',
		
	// targetElmId: dom node id
	targetElmId: null,
	
	// contentElmId: widget content dom node id
	contentElmId: "",	

	widgetBodyElmId: "",
	
	minWidth:20,
	
	minHeight:20,
	
	oldHeight:0,
	
	parentNode:null,
	
	intLeftRTLOrig:0,
	
	intOriginalWidth:0,
	
	isRtl: builderConfig.isBidi,
	
	postCreate: function(){
		if(this.isRtl){
			this.resizeHandlerImage.src = "/mum/images/resize_rtl.png";
		}
		if (dojo.isIE == 6) {
			if (builderConfig.isBidi) {
				dojo.style(this.domNode, {
					left: "-8px",
					bottom: "-34px"
				});
			} else {
				dojo.style(this.domNode, {
					right: "-8px",
					bottom: "-34px"
				});
			}
		}
	},

	_beginSizing: function(/*Event*/ e){
		this.maxSize = this.createMaxSize();
		if (this._isSizing){ 
			return false; 
		}
		this.targetDomNode = dojo.byId(this.targetElmId);
		
		intLeftRTLOrig = parseInt(this.targetDomNode.style.left,10);
		
		intOriginalWidth = parseInt(this.targetDomNode.style.width,10);
		
		if (!this.targetDomNode){ 
			return; 
		}
		
		this._isSizing = true;
		
		if (dojo.isIE){
			this.startPoint  = {'x':event.clientX, 'y':event.clientY};
		}else{
			this.startPoint  = {'x':e.clientX, 'y':e.clientY};
		}

		var mb = dojo._getContentBox(this.targetDomNode);
		this.startSize  = {'w':mb.w, 'h':mb.h};

		this.eventHandles = []; 
		this.eventHandles.push(dojo.connect(document, "onmousemove", this, "_changeSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseup", this, "_endSizing")); 
		this.eventHandles.push(dojo.connect(document, "onmouseleave", this, "_endSizing")); 

		// Publish to the start sizing topic
		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_StartSizing, [this.targetElmId]);
		e.preventDefault();	
	},

	_changeSizing: function(/*Event*/ e){
		// On IE, if you move the mouse above/to the left of the object being resized,
		// sometimes clientX/Y aren't set, apparently.  Just ignore the event.
		try{
			if (dojo.isIE){
				if(!event.clientX  || !event.clientY){
					return; 
				}				
			}else{
				if(!e.clientX  || !e.clientY){
					return; 
				}				
			}
		} catch (ex){
			// sometimes you get an exception accessing above fields...
			return;
		}

		var dx,dy;
		if (dojo.isIE){
			dx = this.startPoint.x - event.clientX;
			dy = this.startPoint.y - event.clientY;
		}else{
			dx = this.startPoint.x - e.clientX;
			dy = this.startPoint.y - e.clientY;
		}
		var newW;
		if(!this.isRtl){
			newW = this.startSize.w - dx;
		}else{
			newW = this.startSize.w + dx;	//for rtl
		}
		
		var newH = this.startSize.h - dy;
		com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeResized(this.targetElmId, newW, dx);

		// minimum size check
		var minWidthExceeded = newW < this.minWidth;
		if (minWidthExceeded) {
			newW = this.minWidth;
		}
		if (newH < this.minHeight) {
			newH = this.minHeight;
		}
		
		// maximum size check
		var maxWidthExceeded = newW > this.maxSize.w;
		if (maxWidthExceeded) {
			newW =this.maxSize.w;
		}
		if (newH > this.maxSize.h) {
			newH = this.maxSize.h;
		}
		
		var contentDiv = dojo.byId(this.contentElmId);
		
		//In Right to Left, move the widget to the left by the same amount that the width is increased.
		var intLeft;
		if (this.isRtl) {
			if(minWidthExceeded){
				intLeft = intLeftRTLOrig + (intOriginalWidth - this.minWidth);
			}else{
				intLeft = maxWidthExceeded ? 0 : intLeftRTLOrig - dx;
			}
		}else{
			intLeft = parseInt(this.targetDomNode.style.left,10);
		}
		
		var intTop = parseInt(this.targetDomNode.style.top,10);
		dojo._setBox(this.targetDomNode,intLeft,intTop,newW,newH);

		if(!this.widgetBodyPadTop){
			this.widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(this.widgetBodyElmId),"paddingTop");
			if (this.widgetBodyPadTop) {
				this.widgetBodyPadTop = parseInt(this.widgetBodyPadTop,10);
			} else {
				this.widgetBodyPadTop = 0;
			}
		}
		var hei = newH - this.widgetBodyPadTop;
		dojo._setMarginBox(contentDiv,0,0,newW,hei);
		if (dojo.isSafari && builderConfig.isBidi) {
			contentDiv.style.width = (parseInt(this.targetDomNode.style.width,10) - 51) + "px";
		}
		// Publish to the change sizing topic
		var sizeDelta = {x: dx, y: dy};
		dojo.publish(com.ibm.mm.builder.eventTopics.Resize_ChangeSizing, [sizeDelta]);
		
		e.preventDefault();
	},

	_endSizing: function(/*Event*/ e){
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		while (this.eventHandles.length > 0) {
			dojo.disconnect(this.eventHandles.pop());
		}
		
		// Publish to the end sizing event topic
		var widgets = dojo.query(".iWidgetSkin[skin]", dojo.byId(this.targetElmId));
		if (widgets.length == 1) {
			// old topic
			dojo.publish(widgets[0].id + com.ibm.mm.builder.eventTopics.Resize_EndSizing, [e]);
			
			// new enabler public ievent
			var widgetBox = dojo.contentBox(widgets[0].id + "_content");
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			var payload = {"newWidth": widgetBox.w,"newHeight": widgetBox.h};
			eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgets[0].id,payload);
			
			// to fix the inconsistent widget size between nav state and backend
			com.ibm.mashups.builder.Personalize.setPersonalizeWidgetState(widgets[0].id, "normal");
			payload = {
				widgetId: widgets[0].id,
				width: parseInt(this.targetDomNode.style.width,10),
				height: parseInt(this.targetDomNode.style.height,10)
			};
			eventService.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
		}		
		
		com.ibm.mm.builder.utils.skinUtil.updateTitleAndIcon(this.targetDomNode.id.replace(/mm_ibm_skin_/,""));
		this._isSizing = false;
		this.widgetBodyPadTop = null;
		
		// clear the max-height
		if (widgets.length == 1) {
			var content = dojo.byId(widgets[0].id + com.ibm.mm.builder.constant.widgetContent);
			if (content) {
				content.style.maxHeight = "";
			}
		}			
	},
	
	createMaxSize:function(){
		var curWidget = dojo.byId(this.targetElmId);
		if(curWidget && this.parentNode){
			var curLeft = parseInt(curWidget.style.left,10);
			var curWidth = parseInt(curWidget.style.width,10);
			var curTop = parseInt(curWidget.style.top,10);	
			var wholeWidth = dojo._getContentBox(this.parentNode).w;
			var wholeHeight = dojo._getContentBox(this.parentNode).h;
			var maxWidth = this.isRtl ? curLeft + curWidth : wholeWidth - curLeft;
			return {
				w: maxWidth,
				h: wholeHeight - curTop
			};
		}
		return null;
	},
	
	destroy : function(){
		this.targetElmId = null;
		this.targetDomNode = null;
		this.inherited(arguments);
	},
	
	onKeyPress: function(evt){
		if (evt.keyCode == dojo.keys.ENTER) {
			this.show();
		}
	},
	
	show: function(){
		if (com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode() != "edit") {
			return;
		}
		clearTimeout(this.showTimer);
		this.showTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "";
			}
		}), 100);
	},
	
	hide: function(){
		if (com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu && com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow) {
			return;
		}
		clearTimeout(this.hideTimer);
		clearTimeout(this.showTimer);
		this.hideTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "none";
			}
		}), 100);
	}
});

}
