if(!dojo._hasResource["com.ibm.widgets.TabBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.TabBar"] = true;
dojo.provide( "com.ibm.widgets.TabBar" );

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("com.ibm.widgets.InlineEditorWrapper");
dojo.require("dijit._KeyNavContainer");
/*
 * Provides Menu widgets using OneUI structure and styles by subclassing dijit.Menu widgets
 * and modifying the templates
 */


dojo.declare( "com.ibm.widgets.TabBar",
			[dijit._Widget, dijit._Templated, dijit._KeyNavContainer],
			{
				// summary: 
				//		Holds a set of tabs in a bar widget.  Provides logic to manage popups
				// 		for each tab (specified by the 'popup' property of the tab widget) if
				//		present.
				
				// class: String class applied to the root node in this widget
				"class": "lotusTabContainer",
				
				// tabListClass: String class applied to the unorderered list node in this 
				// 		widget
				tabListClass: "lotusTabs",
				
				// tabClass: String the class passed in as the class of each tab widget
				//		that is added as a child to this tab bar.  If empty or null, the
				//		tab widget will assume whatever its default class is.
				tabClass: "lotusTab",
				
				// tagWidget: String the name of the widget class to instantiate for each
				//		tab in this tab bar.  Alternatively, simply calling the addChild
				//		function with any widget as the argument will add that widget to
				//		this tab bar, although it may not look appropriate.
				tabWidget: "com.ibm.widgets.Tab",
				
				// tabStrip: Boolean indicating if an additional CSS class is applied to the
				//		root DOM node of this widget which has the value of the class+"Strip"
				//		Example - class = "lotusTabContainer", with tabStrip = true, an additional
				//		class "lotusTabContainerStrip" is added as well.
				tabStrip: false,
				
				// skipPreload: Boolean indicating whether or not this widget should skip an
				//		attempt to preload data found in parsed widget markup.  False by default.
				skipPreload: false,
				
				templateString: '<div class="${class}" waiRole="navigation" dojoAttachPoint="focusNode">'+
									'<ul class="${tabListClass}" waiRole="tablist" dojoAttachPoint="containerNode,tabList" dojoAttachEvent="onkeypress:_onKeyPress"></ul>'+
								'</div>',
				
				attributeMap: dojo.mixin(dojo.clone(dijit._Widget.prototype.attributeMap), {
					tabListClass: {node: "containerNode", type: "class" }
				}),
				
				_setClassAttr: function(/*String*/ value){
					this["class"] = value;
					this.domNode.className = value;
				},
				
				postCreate: function() {
					this.inherited(arguments);
					if (this.tabStrip) {
						dojo.addClass(this.tabList, this["class"] + "Strip");
					}
					var ltr = this.isLeftToRight(),
						k = dojo.keys;
					this.connectKeyNavHandlers(
						ltr ? [k.LEFT_ARROW] : [k.RIGHT_ARROW],
						ltr ? [k.RIGHT_ARROW] : [k.LEFT_ARROW]
					);
				},
				
				startup: function() {
					this.startupKeyNavChildren();
					this.inherited(arguments);
				},
				
				_fillContent: function(/*DomNode*/ source){
					var dest = this.containerNode;
					if(source && dest) {
						var nodes = dojo.query("> ul", source);
						if(nodes.length > 0) {
							this.preloaded = !this.skipPreload;
							this.tabListClass = nodes[0].className;
							this.containerNode.className = this.tabListClass;
							source = nodes[0];
						}
					}
					
					return this.inherited(arguments);
				},
				
				_onKeyPress: function(evt){
					if (evt.ctrlKey || evt.altKey) {
						return;
					}
					if (evt.charOrCode == dojo.keys.DOWN_ARROW) {
					 	this._moveToPopup(evt);
					 	dojo.stopEvent(evt);
					}	
				},
				_onNodeBlur: function(evt){
					// when focus leaves a child,
					// reinstate the container's tabindex
					/*
					var item = dijit.getEnclosingWidget(evt.target);
					this._onChildBlur(item);
					*/
					this._startCloseTimer();
					this.inherited(arguments);
				},
				_onChildBlur: function(item) {
					if (item.popup) {
						dijit.popup.close(item.popup);
					}
					item._blur();
				},
				_moveToPopup: function(/*Event*/ evt){
					if(this.focusedChild && this.focusedChild.popup && !this.focusedChild.disabled) {
						this._openPopup(this.focusedChild, true);
					}
				},
				_moveToNextPopup: function() {
					this.focusNext();
				},
				_openPopup: function(item, focus) {
					var popup = item.popup;
					if (!popup) {
						return false;
					}
					if(this.currentPopup == popup) {
						if(focus && popup.focus) {
							popup.focus();
						}
						return false;
					}
					var me = this;
					var ori = {'BL':'TL', 'TL':'BL'};
					if (!this.isLeftToRight())
					{
						ori = {'BR':'TR', 'TR':'BR'};
					}
					dijit.popup.open({
						parent: this,
						popup: popup,
						orient: ori,
						around: item.domNode,
						onCancel: function() {
							if (popup.close) {
								popup.close();
							}
							else {
								dijit.popup.close(popup);
							}
							item.focus();
							me.currentPopup = null;
						},
						onClose: function() {
							me.currentPopup = null;
						}
					});
					
					this.currentPopup = popup;
					
					if(focus && popup.focus) {
						popup.focus();
					}
					
					return true;
				},
				
				_closePopup: function() {
					if(this.currentPopup) {
						if (this.currentPopup.close) {
							this.currentPopup.close();
						}
						else {
							dijit.popup.close(this.currentPopup);
						}
					}
					this.currentPopup = null;
				},
				
				_startCloseTimer: function() {
					if(this.currentPopup) {
						if(this.currentPopup._startCloseTimer) {
							// the popup supports the _startCloseTimer function, call it
							this.currentPopup._startCloseTimer();
						}
						else {
							// if it does not, close it immediately
							this._closePopup();
						}
					}
				},
				
				_stopCloseTimer: function() {
					if(this.currentPopup && this.currentPopup._stopCloseTimer) {
						this.currentPopup._stopCloseTimer();
					}
				},
				_onItemAccent: function(child, focus) {
					if (child.attr("disabled")) {
						return;
					}
					// stop any close timers
					this._stopCloseTimer();
					if(this.currentPopup) {
						if (this.currentPopup.canClose && !this.currentPopup.canClose()) {
							return;
						}
						if(this.currentPopup != child.popup) {
							// close the existing popup if it's not the one associated with hovered item
							// close it immediately without allowing any animation or effect so that
							// the new menu that's being opened will display correctly
							dijit.popup.close(this.currentPopup);
						}
					}
					// open the hovered item popup
					this._openPopup(child, focus);
				},
				onItemFocus: function(child) {
					//this._onItemAccent(child, false);
				},
				onItemClick: function(child, evt) {
					if (child.attr("disabled")) {
						return;
					}
					child.onClick(evt);
				},
				onItemHover: function(child, evt) {
					this._onItemAccent(child, false);
				},
				onItemUnhover: function(item) {
					this._startCloseTimer();
				},
				onPopupDestroyed: function(popup) {
					// called when a child tab's popup is destroyed
					if(popup == this.currentPopup) {
						this.currentPopup = null;
					}
				}
			}
);

dojo.declare( "com.ibm.widgets._TabBase",
			[dijit._Widget, dijit._Templated, dijit._Contained],
			{
				"class": "lotusTab",
				_setDisabledAttr: function(/*Boolean*/ value){
					this.disabled = value;
					dojo[value ? "addClass" : "removeClass"](this.domNode, "disabled");
					dijit.setWaiState(this.focusNode, 'disabled', value ? 'true' : 'false');
				},
				_setClassAttr: function(/*String*/ value){
					this["class"] = value;
					this.domNode.className = value;
				},
				focus: function(){
					dijit.focus(this.focusNode);
				},
				onFocus: function() {
					this.getParent().onItemFocus(this);
				},
				_onHover: function(evt) {
					this.getParent().onItemHover(this, evt);
				},
				_onUnhover: function(evt) {
					this.getParent().onItemUnhover(this, evt);
				},
				_blur: function() {
					// called by parent to perform any blur action on this item
				}
			}
);

dojo.declare( "com.ibm.widgets.Tab",
			com.ibm.widgets._TabBase,
			{
				iconClass: "",
				href: "",
				label: "",
				
				templatePath: dojo.moduleUrl("com.ibm.widgets", "templates/Tab.html"),
								
				attributeMap: dojo.mixin(dojo.clone(dijit._Widget.prototype.attributeMap), {
					label: {node: "labelNode", type: "innerHTML"},
					href: {node: "linkNode", type: "attribute"},
					iconClass: {node: "iconNode", type: "class" }
				}),
				_setDndHandleAttr: function(value) {
					this.dndHandle = value;
					dojo[value ? "addClass" : "removeClass"](this.dndHandleNode, "dojoDndHandle");
				},
				postCreate: function() {
					this.inherited(arguments);
					if(this.popup) {
						this.setPopup(this.popup);
					}
				},
				
				_fillContent: function(/*DomNode*/ source){
					var dest = this.containerNode;
					var handled = false;
					if(source && dest) {
						var nodes = dojo.query("a", source);
						if(nodes.length > 0) {
							handled = true;
							this.linkNode.setAttribute("href", nodes[0].getAttribute("href"));
							while(nodes[0].hasChildNodes()) {
								this.linkNode.appendChild(nodes[0].firstChild);
							}
						}
					}
					if (!handled) {
						return this.inherited(arguments);
					}
				},
				
				setPopup: function(popup) {
					this.popup = popup;
					this.popup.anchor = this;
					this.popup.startup();
					dijit.setWaiState(this.linkNode, "haspopup", "true");
				},
				destroyPopup: function() {
					if(this.popup) {
						this.popup.destroyRecursive();
						var parent = this.getParent();
						if (parent) {
							parent.onPopupDestroyed(this.popup);
						}
						delete this.popup;
						dijit.setWaiState(this.linkNode, "haspopup", "false");
					}
				},
				destroyDescendants: function() {
					this.destroyPopup();
					this.inherited(arguments);
				},
				
				startup: function() {
					this.inherited(arguments);
					if (this.popup) {
						this.popup.startup();
					}
				},
				_onClick: function(evt) {
					var p = this.getParent();
					if(p) {
						p.onItemClick(this, evt);
						dojo.stopEvent(evt);
					}
				},
				onClick: function(evt) {
					
				}
			}
);


dojo.declare( "com.ibm.widgets.ShowEditorTab",
			com.ibm.widgets._TabBase,
			{
				"class": "showEditorTab",
				templateString:	'<li class="${class}" dojoAttachPoint="containerNode" dojoAttachEvent="onclick:onClick">'+
									'<a dojoAttachPoint="focusNode" waiRole="menuitem" class="tabLabel" onclick="javascript:return false;" href="javascript:void(0);">${label}</a>'+
								'</li>',

				
				postCreate: function() {
					this.inherited(arguments);
					dojo.setSelectable(this.domNode, true);
					if(this.popupWidget) {
						var cls = dojo.getObject(this.popupWidget);
						this.popup = new cls(this.popupParams);
						this.connect(this.popup, "onChange", "onChange");
						this.connect(this.popup, "onCancel", "onCancel");
						this.connect(this.popup, "focus", "onEdit");
					}
				},
				onFocus: function() {
					
				},
				onChange: function(value) {
					
				},
				onCancel: function() {
					
				},
				onEdit: function() {
					
				},
				onClick: function(evt) {
					if (this.popup){
						// Check if there is a page manager and bring up the save changes dialog.
						if (typeof ibmPortalConfig != "undefined" && typeof ibmPortalConfig.savePageManager != "undefined" && typeof ibmPortalConfig.savePageManager.leavePage != "undefined") {
							var dialog = this.popup;
							var dialogOpen = function() { dialog.focus(); };
							ibmPortalConfig.savePageManager.leavePage(dialogOpen);
						}
						else {
							this.popup.focus();
						}
					}
				}
			}
);

dojo.declare( "com.ibm.widgets.EditorTab",
			[com.ibm.widgets._TabBase, com.ibm.widgets.InlineEditorWrapper],
			{
				templatePath: dojo.moduleUrl("com.ibm.widgets", "templates/EditorTab.html"),
				
				"class": "lotusTab",
				
				postCreate: function() {
					this.inherited(arguments);
					dojo.setSelectable(this.domNode, true);
				}	
			}
);

}
