/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mm.builder.spaceEditorWidget");

dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl");

dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");

dojo.declare("com.ibm.mm.builder.spaceEditorWidget", null, {	

	WID: null,
	
	SPACE_CREATE_TYPE_EMPTY: "from_empty",
	
	SPACE_CREATE_TYPE_TEMPLATE: "from_template",
	
	resourceBundle:null,
	
	ownerName:null,
	
	ownerId:null,
	
	title:null,
	
	theme:null,
	
	icon:null,
	
	description:null,
	
	spaceModel:null,
	
	space:null,
	
	resourceMessage : null,
	
	user:null,
	
	acModel:null,
	
	eventService: com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME),
	
	propChanged: {titleChanged:false, descChanged: false, ownerChanged: false, themeChanged: false, iconChanged: false},
	
	onLoad: function(){
		this._connections = [];
		this._subscriptions = [];
		var widgetId = this.iContext.widgetId;
		this.WID = "_"+ widgetId + "_";

		this.resourceBundle = com.ibm.mm.builder.coreWidgetsStrings;
		this.resourceMessage = com.ibm.mm.builder.coreWidgetsMessages;
		
        var themesNode = dojo.byId(this.WID + "themesContainer");
		
		this.themesListControl = new com.ibm.mm.builder.iwidget.spacemanager.widget.ThemesListControl({
			widgetId: widgetId
		}, themesNode);
		dijit.setWaiState(this.themesListControl.domNode, "labelledby", this.WID + "choose_theme_label");
		
		var iconsNode = dojo.byId(this.WID + "iconsContainer");
		
		this.iconsListControl = new com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl({
			widgetId: widgetId
		}, iconsNode);
		dijit.setWaiState(this.iconsListControl.domNode, "labelledby", this.WID + "choose_icon_label");
				
        this.spaceModel = com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
		
		this._subscriptions.push(dojo.subscribe("com.ibm.mm.builder.spaceEditorWidget.OwnerName", dojo.hitch(this, this._setOwnerName)));
		this._subscriptions.push(dojo.subscribe("com.ibm.mm.builder.spaceEditorWidget.OwnerId", dojo.hitch(this, this._changeOwnerId)));
		this._subscriptions.push(dojo.subscribe("com.ibm.mm.builder.spaceEditorWidget.ChangePermission",dojo.hitch(this,this._changePermission)));	
				
	},
	
	_changePermission:function(roleType){
		var editor = com.ibm.mashups.enabler.ac.RoleType.EDITOR;
		var viewer = com.ibm.mashups.enabler.ac.RoleType.USER;
		var acUtil = com.ibm.mm.builder.utils.acModelUtil;
		this.setRoleToNone = false;
		
		var memberIdList = {};
		var owner = this.acModel.getOwner();
		if (owner) {
			memberIdList[owner.getID()] = "user";
		}
		if (roleType == "none"){
			acUtil.removeMembersWithRoleType(this.acModel, viewer, memberIdList);
			acUtil.removeMembersWithRoleType(this.acModel, editor, memberIdList);
			// Need to redirect page if currently in the space
			this.setRoleToNone = true; 
		} else {
			if (roleType == editor){
				acUtil.removeMembersWithRoleType(this.acModel, viewer, memberIdList);
				acUtil.insertMemberWithRoleType(this.acModel, memberIdList, editor);
			} else if (roleType == viewer){
				acUtil.removeMembersWithRoleType(this.acModel, editor, memberIdList);
				acUtil.insertMemberWithRoleType(this.acModel, memberIdList, viewer);
			}
		}
		
		this.acModel.commit().start();
	},
		
	_onLoadChangeOwnerWithKey: function(e) {
		if (e.charCode == dojo.keys.SPACE || e.keyCode == dojo.keys.ENTER) {
			this.onLoadChangeOwner(e);
		}		
	},
	
	onLoadChangeOwner: function(){
		var payload = {
			widgetTypeId: "spaceChangeOwnerWidget",
			eventName: "com.ibm.mashups.builder.spaceChangeOwner",
			eventPayload: this.ownerId,
			dialogParam: {
				title: this.resourceBundle.CHANGE_SPACE_OWNER_CAPTION,
				nodeWidth: "500px",
				leftBarWidth: "0px",
				rightBarWidth: "0px",
		    	containerBackgroundColor: "white",
		    	hasRightBottomResizer: false
			}
		};
		
		this.eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
		
	},
	
	onView: function(){
		dojo.parser.parse(this.iContext.getRootElement());
		this._spaceNameField = dojo.byId(this.WID + "SpaceName");
		this._connections.push(dojo.connect(this._spaceNameField, "onkeypress", this, "onPressEnter"));        
		dojo.byId(this.WID+"space_information_label").innerHTML = this.resourceBundle.EDIT_SPACE_INFORMATION;
		dojo.byId(this.WID+"space_theme_label").innerHTML = this.resourceBundle.EDIT_SPACE_THEME;
		dojo.byId(this.WID+"space_icon_label").innerHTML = this.resourceBundle.EDIT_SPACE_ICON;
		dojo.byId(this.WID+"space_name_label").innerHTML = this.resourceBundle.CREATE_SPACE_NAME;
		dojo.byId(this.WID+"space_desc_label").innerHTML = this.resourceBundle.CREATE_SPACE_DESC;
		dojo.byId(this.WID+"space_owner").innerHTML = this.resourceBundle.EDIT_SPACE_OWNER;
		dojo.byId(this.WID+"choose_theme_label").innerHTML = this.resourceBundle.EDIT_SPACE_CHOOSE_THEME;
		dojo.byId(this.WID+"choose_icon_label").innerHTML = this.resourceBundle.EDIT_SPACE_CHOOSE_ICON;
		dojo.byId(this.WID+"change_text").innerHTML = this.resourceBundle.EDIT_SPACE_CHANGEOWNER;
	},
	
	
	onPressEnter: function(event) {
		if(event.keyCode==13) {
 			this.save();
		}
	},
	
	onEditSpace: function(iEvent) {
		if(iEvent.payload && iEvent.payload.spaceId){
			this.spaceId = iEvent.payload.spaceId;
			this.editSpaceInSpaceManager = true;
		}else{
			this.spaceId = iEvent.payload;
			this.editSpaceInSpaceManager = false;
		}
		
		this.cleanUI();
		this.space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(this.spaceId);
		this.loadThemes();
		this.loadIcons();
		this.loadSpaceModel();		
		for(var p in this.propChanged){				
			if(Object.prototype.hasOwnProperty.call(this.propChanged,p)) {
       			this.propChanged[p] = false;
    		}			
		}
		
		if (!this._canChangeOwner()) {
            dojo.style(dojo.byId(this.WID+"change_text"), "display", "none");
        }else{
			dojo.style(dojo.byId(this.WID+"change_text"), "display", "");
		}
	},
	
	
	saveSpaceModel: function() {
		this.space.setTitle(this.title, dojo.locale);
		this.space.setDescription(this.description, dojo.locale);	
		com.ibm.mm.builder.utils.spaceUtil.setSpaceIconURL(this.space, this.iconUrlEncode(this.icon));
		
		com.ibm.mm.builder.utils.spaceUtil.getSpaceModel().commit().start();
		
		 // user model, get current user
    	if (!this.userModel){
			this.userModel = com.ibm.mashups.enabler.user.Factory.getUserModel();
		}

		//set theme begin
		var navigationUtil = com.ibm.mm.builder.utils.navigationUtil;		
		var navigationModel = navigationUtil.getNavigationModel();
		var navRootNode = navigationModel.find(this.space.getRootNavigation()).start();		
		navRootNode.setTheme(this.theme);	
		navigationModel.commit().start();
		
		//owner		
		if (this.ownerId!== null && this.ownerId !== ""){
			this.eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
			this.user = this.userModel.find(this.ownerId).start();
			this.acModel.setOwner(this.user);
			var deferredAc = this.acModel.commit();
			deferredAc.start();
		}

		
		var spaceId = this.space.getID();
		//com.ibm.mm.builder.utils.spaceUtil.getSpaceModel(true);
		
		if(this.propChanged.ownerChanged){
			var space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId);

			// check for admin access
			var hasAdmin = false;
			if (space) {
				var ea = com.ibm.mashups.enabler.ac.AccessFactory.getEffectiveAccess(space);
				hasAdmin = ea ? ea.hasRole("ADMINISTRATOR") : false;			
			}
			
			var needRemoveSpace = false;
			if (this.setRoleToNone) {
				var spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
				needRemoveSpace = hasAdmin ? false : true;
			}
			
			var needRemoveSpace = hasAdmin ? false: this.setRoleToNone;		
			dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space["delete"],[spaceId]);
			dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.CHANGE_OWNER, {spaceId:spaceId, needRemoveSpace: needRemoveSpace}]);
			if(!this.editSpaceInSpaceManager){				
				this.eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace", com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId() || com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId());
			}
			else{
				var currentSpaceId = com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId();
				this.eventService.broadcastEvent("com.ibm.mashups.builder.spacemanager.spaceOwnerChanged", {spaceId: spaceId, currentSpaceId: currentSpaceId});
			}
			// redirect to other space when we have no access and we are in the current space
			if(spaceId==com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId() && this.setRoleToNone==true) {
				var space = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId);
				if (!hasAdmin) {
					this.eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace", com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId() || com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId());
				}
			}
		}
		var spaceItem=null;
		
		if(this.propChanged.themeChanged){			
			if(this.propChanged.titleChanged){
				this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
			     spaceItem = {"id": this.spaceId, "title": this.title};
				dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.changeSpaceTitle,[spaceItem]);
			}

		}else if(this.propChanged.titleChanged){
			
			this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");				
			 spaceItem = {"id": this.spaceId, "title": this.title};
			dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.changeSpaceTitle,[spaceItem]);
			dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.EDIT_SPACE, {spaceId:spaceId}]);
			
		}else if(this.propChanged.descChanged || this.propChanged.iconChanged){
			dojo.publish(com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Topic.Space.refresh,[com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants.Action.EDIT_SPACE, {spaceId:spaceId}]);
		}
	},
	
	loadSpaceModel: function() {
		if (!this.space) {
			return;
		}
        
		// find the selected node
		this.acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(this.space);
		
        if (this.space) {

			// titles				
		   this._setTitle(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(this.space)));
		   
			// description
           this._setDescription(com.ibm.mm.builder.utils.htmlUtil.unEscapeString(com.ibm.mm.builder.utils.enablerUtil.getNodeDescription(this.space)));

		   // icon
		   var iconUrl = com.ibm.mm.builder.utils.spaceUtil.getSpaceIconURL(this.space);
		   if (iconUrl) {
				this._setSelectedIcon(this.iconUrlDecode(iconUrl));
		   }
		   
		   // owner
		   if (this.acModel.getOwner() !== null && this.acModel.getOwner() !== "") {
		   		
				this._setOwnerId(this.acModel.getOwner().getID());
				this._setOwnerName(this.acModel.getOwner().getDisplayName());
		   } else {
		   		dojo.byId(this.WID+"space_owner").innerHTML = this.resourceBundle.EDIT_NO_SPACE_OWNER;
		   }
		   
        } else {
            return;
        }

	},

	loadThemes: function(){
	
		var navRootNodeId = this.space.getRootNavigation().getID();			
		var pageUtil = com.ibm.mm.builder.utils.pageUtil;
		var navRootNode = pageUtil.getPageNode(navRootNodeId);	
		
		var theme = navRootNode.getTheme();
		if(!theme) {			
			var themeUtil = com.ibm.mm.builder.utils.themeUtil;
			theme = themeUtil.getDefaultThemeId();
		}
		this.theme = theme;
		this.themesListControl.refresh(theme);
	},
	
	loadIcons: function(){
		this.iconsListControl.refresh();
	},
	
	cleanUI: function(){
		dojo.byId(this.WID+"SpaceName").value = "";
		dojo.byId(this.WID+"SpaceDesc").value = "";
	},
	
	_getTitle: function(){
		return dojo.byId(this.WID+"SpaceName").value;
	},
	
	_getDescription: function(){
		return dojo.byId(this.WID+"SpaceDesc").value;
	},	

	_getSpaceOwner: function(){
		return dojo.byId(this.WID+"space_owner_value").innerHTML;
	},
	
	_getSelectedTheme: function(){
		return this.themesListControl.selectedTheme;
	},
	
	_getSelectedIcon: function(){
		return this.iconsListControl.getSelectedIconId();
	},
	
	_getOwnerId : function(){
		return this.ownerId;
	},
	
	iconUrlDecode: function(iconUrl){
		var indexS = iconUrl.lastIndexOf('/');
		var indexE = iconUrl.lastIndexOf('.');
		return(iconUrl.substring(indexS + 6, indexE));
	},
	
	iconUrlEncode: function(iconId){
		return builderConfig.builderPath + "/images/spaceicons/icon-" + iconId + ".gif"; //JSLINT-IGNORE
	},
	
	hide: function(){	
		if (this.messageControl) {
			this.messageControl.hide();
		}
		this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
	},

	_verifyInput: function(title, description){
		var spaceNameInput = dojo.byId(this.WID+"SpaceName");
		var spaceDescInput = dojo.byId(this.WID+"SpaceDesc");
		
		if(!title || dojo.trim(title) === ""){		
			dojo.attr(spaceNameInput, "aria-invalid", "true");					
			this.messageControl.attr("message", this.resourceMessage.E_SPACE_MANAGER_SPACE_NAME_IS_REQUIRED_0);			
			this.messageControl.show();			
			return false;
		}
		if (!com.ibm.mm.builder.utils.spaceUtil.validateSpaceName(title)) {
			dojo.attr(spaceNameInput, "aria-invalid", "true");					
			return false;
		}
		dojo.removeAttr(spaceNameInput, "aria-invalid");
		
		if (description && dojo.isString(description)) {
			if (description.length >= 512) {
				dojo.attr(spaceDescInput, "aria-invalid", "true");					
				this.messageControl.attr("message", this.resourceMessage.E_SPACE_MANAGER_SPACE_DESC_HAS_MAX_LIMIT_0);
				this.messageControl.show();
				return false;
			}
		}							
		dojo.removeAttr(dojo.byId(this.WID+"SpaceDesc"), "aria-invalid");					
		return true;
	},
	
	save: function(){		
		
		//init the error message 
		if(!this.messageControl) {
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
	    	dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
			this.messageControl = new com.ibm.lotus.oneui.v100.messages.Message({messageType: 'error'}, this.WID+"messageBox");
			this.messageControl.hide(); 	
		}
		//validation
		if (!this._verifyInput(this._getTitle(), this._getDescription())) {
			return;
		}
		//validation
		if (this.title != this._getTitle()) {
			this.propChanged.titleChanged = true;
		}
		this.title = this._getTitle();
		
		if (this.description != this._getDescription()) {
			this.propChanged.descChanged = true;
		}
		this.description = this._getDescription();
		
		if (this.theme != this._getSelectedTheme()) {
			this.propChanged.themeChanged = true;
		}
		this.theme = this._getSelectedTheme();
		
		if (this.icon != this._getSelectedIcon()) {
			this.propChanged.iconChanged = true;
		}
		this.icon = this._getSelectedIcon();
		
		this.saveSpaceModel();		
		this.messageControl.hide();
		this.hide();
	},
	
	_setOwnerName : function(name) {
		this.ownerName = name;
		dojo.byId(this.WID+"space_owner_value").innerHTML = name;
	},
	
	_setOwnerId : function(id) {
		this.ownerId = id;
	},
	_changeOwnerId: function(id) {
		if (this.ownerId != id) {
			this.propChanged.ownerChanged = true;
		}
		this.ownerId = id;
	},
	
	_canChangeOwner : function() {
        return com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.canChangeOwner(this.spaceId);
    },
	
	_setSelectedTheme : function(theme) {
		this.theme = theme;
		this.themesListControl.setSelectedTheme(theme);
	},
	
	_setDescription : function(desc) {
		if (!desc) {
			desc = "";
		}
		this.description = desc;
		dojo.byId(this.WID+"SpaceDesc").value = this.description;
	},
	
	_setTitle : function(name) {
		this.title = name;
		dojo.byId(this.WID+"SpaceName").value = this.title;
	},
	
	_setSelectedIcon : function(iconUrl) {
		this.icon = iconUrl;
		this.iconsListControl.setSelectedIcon(iconUrl);
	},
	
	onUnload: function() {
		dojo.forEach(this._connections, dojo.disconnect);
		dojo.forEach(this._subscriptions, dojo.unsubscribe);
		this.iconsListControl.destroy();
	}
	
});
