/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.itemset.ManagedItemSet");


dojo.require("com.ibm.mashups.iwidget.itemset.ManagedItemSetCallbackModel");

//<INTERFACE>
/**
 Interface to a simple abstraction of a datamodel. This provides a base from which more sofisticated datamodel can be built.
 There're 3 default ManagedItemSet provided in Lotus Mashups. They are attributes, userprofile and  idescriptor.<p/>
 @ibm-api
 @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.itemset.ManagedItemSet",null, {
    /**
     @private
     */
    constructor: function() {
    },
    /**
     This method requests the iContext save the current state of the ManagedItemSet.
     The iContext MAY also choose to save the ManagedItemSet at times other than when iWidgets request a save.
     This method MAY operate asynchronously.  The iContext  MUST invoke any supplied callbackFn upon completion of the save attempt.
     It need to be implemented by each subclass...signiture of callback function is as follows</br>
     &nbsp;&nbsp;&nbsp;<code>function(in String managedItemSetName, in Boolean success);</code>
     @param{com.ibm.mashups.iwidget.itemset.ManagedItemSetCallbackModel.postSaveCallbackFn}callbackfn optional callback function
     @type void
     @deprecated use commit(callbackfn) instead
     */
    save: function(callbackfn) {
    },
	 /**
     This method requests the queued change be processed. This includes simultaneous changes to multiple items and any persistence or other propagation of the values.
     This method MAY operate asynchronously.  The iContext  MUST invoke any supplied callbackFn upon completion of the commit attempt.
     It need to be implemented by each subclass...signiture of callback function is as follows</br>
     &nbsp;&nbsp;&nbsp;<code>function(in String managedItemSetName, in Boolean success);</code>
     @param{com.ibm.mashups.iwidget.itemset.ManagedItemSetCallbackModel.postSaveCallbackFn}callbackfn optional callback function
     @type void
     */
    commit: function(callbackfn) {
    },
	  /**
     This method sets an item within the ItemSet, creates or replaces an existing entry as needed.
     To append a value to any existing item, suggest to get the current value of this item and append
     the new value to the list and supply the result to this method.
     Marking an item as ReadOnly indicates to the iContext that while this item maybe shared with other components
     on the page, the access of those components should not include changing or removing item.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @param{String}value value of the item. Must never be <code>null</code>.
     @param{Boolean}readOnly optional Boolean attribute to indicate this item is readOnly or not.Default value is false if this parameter is not provided.
     @return{ItemSet} return an handle of ItemSet upon successful, <code>null</code> upon failure.
     @deprecated use setItemValue(itemName,value) instead
     */
    setItemValue: function( /*String*/itemName, /*Object*/ value,/*boolean*/ readOnly) {
        return this;
    },
	 /**
     This method sets an item within the ItemSet, creates or replaces an existing entry as needed.
     With the actual setting/processing of the change happening when commit() is invoked.As ManagedItemSet are controlled by
     the iContext, some items may be read only to the iwidget. 
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @param{String}value value of the item. Must never be <code>null</code>.
     @return{ItemSet} return an handle of ItemSet upon successful, <code>null</code> upon failure.
     */
    setItemValue: function( /*String*/itemName, /*Object*/ value) { // JSLINT-IGNORE: in Java functions with the same name but different signatures are allowed - this is only used for generating JavaDoc
        return this;
    },
    /**
     This method returns the value for the named item from the set.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @return{String} return value of the named item for the set, <code>null</code> upon failure.
     */
    getItemValue: function( /*String*/itemName) {
        return null;
    },
    /**
     This method returns an array of Strings, providing the name of each item.
     @return{String[]}  return an array of items names and return <code>null</code> if the set contains no item
     */
    getAllNames: function() {
        return null;
    },
    /**
     Removes the named item from the set.
     @param{String}itemName name of the item that needs to be removed. Must never be <code>null</code>.
     @return{ItemSet} return the handle to the ManagedItemSet upon successful, <code>null</code> upon failure.
     */
    removeItem: function(/*String*/itemName) {
        return null;
    },
    /**
     This method returns a new ItemSet which is a duplicate of the current ItemSet.
     @return{ItemSet}  return a new ItemSet which contains all the data item in the current ItemSet
     @deprecated not used
     */
    clone: function() {
        return null;
    },
    /**
     This method returns a Boolean indicating whether or not the item specified by the supplied name can be modified by the user.
     @param{String}itemName name of the required Item. Must never be <code>null</code>.
     @return{Boolean} return a Boolean indicating whether or not the item specified by the supplied name can be modified by the user. Never <code>null</code>.
     */
    isReadOnly: function(/*String*/itemName) {
        return null;
    },
    /**
     As a limitation in Lotus Mashups, this method returns <code>null</code>.
     @return{Object} return As a limitation in Lotus Mashups, this method returns <code>null</code>.
     @deprecated not used
     */
    getItemSetDescription: function() {
        return null;
    },
	/**
     This function adds listener to this ShareableItemSet. So it will gets notified when this ShareableItemSet is updated.
     @param{Function}listener js function that should already be properly scoped. Must never be <code>null</code>.
     @return{String} return listener id if listener is registered successfully, return null if it's not.
     */
    addListener: function(/*Function*/listener) {
        return null;
    },
    /**
     This function removes the  listener from this ShareableItemSet.
     @param{String}listenerId  listener id that's returned by the system when listener is added. Must never be <code>null</code>.
     @return{Boolean} return true if listener is removed successfully.
     */
    removeListener: function(/*String*/listenerId) {
        return true;
    } //return true if listener is removed successfully
});
//</INTERFACE>
dojo.require("com.ibm.mm.iwidget.manageditemset.IDescriptorDefaultImpl");
